import processing.core.*; 
import processing.xml.*; 

import oscP5.*; 
import netP5.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class tra_on extends PApplet {




OscP5 oscP5;
NetAddress myRemoteLocation;

String symbols [][] = new String [8][16];
int values [][] = new int [8][16];
String cell;
int posx = 0;
int posy = 0;
int xmv = 0;
int ymv = 0;
int read = 0;
int on = 0;


public void setup () {
  size (800,400);
  background (255);
  frameRate (12);
  oscP5 = new OscP5 (this,12000);
  myRemoteLocation = new NetAddress ("127.0.0.1",12000);
    
    for (int x = 0 ; x < 8; x++) {
    for (int y = 0; y < 16; y ++) {
      symbols [x][y] = ". . . .";
      values [x][y] = 0;
      
    }
  }
}
  
public void draw () {
  background (255);
  for (int x = 0 ; x < 8; x++) {
    for (int y = 0; y < 16; y ++) {
      line (x * 100, 0, x * 100, 400);
      line (0, y * height / 16, width, y * height / 16);
      
      cell = symbols [x][y];
      fill (0);
      text (cell,x * 100 + 5 ,y * 25 + 20);
      }
  }
  
  read = ((read + 1) % 16) * on;
  
  int out1 = values[0][read];
  int out2 = values[1][read];
  int out3 = values[2][read];
  int out4 = values[3][read];
  int out5 = values[4][read];
  int out6 = values[5][read];
  int out7 = values[6][read];
  int out8 = values[7][read];
  
  // Out
  
  if (on > 0) {
    OscMessage au1 = new OscMessage ("/ch1");
    au1.add(out1);
    oscP5.send (au1, myRemoteLocation);
    
    OscMessage au2 = new OscMessage ("/ch2");
    au2.add(out2);
    oscP5.send (au2, myRemoteLocation);
    
    OscMessage au3 = new OscMessage ("/ch3");
    au3.add(out3);
    oscP5.send (au3, myRemoteLocation);
    
    OscMessage au4 = new OscMessage ("/ch4");
    au4.add(out4);
    oscP5.send (au4, myRemoteLocation);
    
    OscMessage au5 = new OscMessage ("/ch5");
    au5.add(out5);
    oscP5.send (au5, myRemoteLocation);
    
    OscMessage au6 = new OscMessage ("/ch6");
    au6.add(out6);
    oscP5.send (au6, myRemoteLocation);
    
    OscMessage au7 = new OscMessage ("/ch7");
    au7.add(out7);
    oscP5.send (au7, myRemoteLocation);
    
    OscMessage au8 = new OscMessage ("/ch8");
    au8.add(out8);
    oscP5.send (au8, myRemoteLocation);
  
}
 
 
  
  fill (0,100,200,100);
  rect (0, read * height / 16, width, height / 16);
  fill (0,0,200,100);
  rect (posx,posy, width / 8, height / 16); 
  
  fill (100,100,100,50);
  rect (0,0,width ,height/16);
  rect (0,(height / 16) * 4,width ,height/16);
  rect (0,(height / 16) * 8,width ,height/16);
  rect (0,(height / 16) * 12,width ,height/16);
}

public void keyPressed () {
  
  // Cursor
  
  if (keyCode == RIGHT) {
    xmv = min (xmv + 1, 7);
    posx = (xmv * width / 8);
  }
  if (keyCode == LEFT) {
    xmv = max (xmv - 1, 0);
    posx = (xmv * width / 8);
  }
  if (keyCode == UP) {
    ymv = max (ymv - 1, 0);
    posy = (ymv * height / 16);
  }
  if (keyCode == DOWN) {
    ymv = min (ymv + 1, 15);
    posy = (ymv * height / 16);
  }
  
  // Record
  
  if (key == 'z') {
    fill (0);
    symbols [xmv][ymv] = "C-4";
    values [xmv][ymv] = 60;
 }
  if (key == 's') {
    fill (0);
    symbols [xmv][ymv] = "C#4";
    values [xmv][ymv] = 61;
 }
  if (key == 'x') {
    fill (0);
    symbols [xmv][ymv] = "D-4";
    values [xmv][ymv] = 62;
 }
  if (key == 'd') {
    fill (0);
    symbols [xmv][ymv] = "D#4";
    values [xmv][ymv] = 63;
 }
  if (key == 'c') {
    fill (0);
    symbols [xmv][ymv] = "E-4";
    values [xmv][ymv] = 64;
 }
  if (key == 'v') {
    fill (0);
    symbols [xmv][ymv] = "F-4";
    values [xmv][ymv] = 65;
 }
  if (key == 'g') {
    fill (0);
    symbols [xmv][ymv] = "F#4";
    values [xmv][ymv] = 66;
 }
  if (key == 'b') {
    fill (0);
    symbols [xmv][ymv] = "G-4";
    values [xmv][ymv] = 67;
 }
  if (key == 'h') {
    fill (0);
    symbols [xmv][ymv] = "G#4";
    values [xmv][ymv] = 68;
 }
  if (key == 'n') {
    fill (0);
    symbols [xmv][ymv] = "A-4";
    values [xmv][ymv] = 69;
 }
  if (key == 'j') {
    fill (0);
    symbols [xmv][ymv] = "A#4";
    values [xmv][ymv] = 70;
 }
  if (key == 'm') {
    fill (0);
    symbols [xmv][ymv] = "B-4";
    values [xmv][ymv] = 71;
 }
  if (key == 'q') {
    fill (0);
    symbols [xmv][ymv] = "C-5";
    values [xmv][ymv] = 72;
 }
  if (keyCode == '2') {
    fill (0);
    symbols [xmv][ymv] = "C#5";
    values [xmv][ymv] = 73;
 }
  if (key == 'w') {
    fill (0);
    symbols [xmv][ymv] = "D-5";
    values [xmv][ymv] = 74;
 }
  if (keyCode == '3') {
    fill (0);
    symbols [xmv][ymv] = "D#5";
    values [xmv][ymv] = 75;
 }
  if (key == 'e') {
    fill (0);
    symbols [xmv][ymv] = "E-5";
    values [xmv][ymv] = 76;
 }
  if (key == 'r') {
    fill (0);
    symbols [xmv][ymv] = "F-5";
    values [xmv][ymv] = 77;
 }
  if (keyCode == '5') {
    fill (0);
    symbols [xmv][ymv] = "F#5";
    values [xmv][ymv] = 78;
 }
  if (key == 't') {
    fill (0);
    symbols [xmv][ymv] = "G-5";
    values [xmv][ymv] = 79;
 }
  if (keyCode == '6') {
    fill (0);
    symbols [xmv][ymv] = "G#5";
    values [xmv][ymv] = 80;
 }
  if (key == 'y') {
    fill (0);
    symbols [xmv][ymv] = "A-5";
    values [xmv][ymv] = 81;
 }
  if (keyCode == '7') {
    fill (0);
    symbols [xmv][ymv] = "A#5";
    values [xmv][ymv] = 82;
  }
   if (key == 'u') {
    fill (0);
    symbols [xmv][ymv] = "B-5";
    values [xmv][ymv] = 83;
   }
    if (keyCode == DELETE) {
    fill (0);
    symbols [xmv][ymv] = ". . . .";
    values [xmv][ymv] = 0;
    }
    
    // ON/OFF
    
    if (keyCode == ENTER) {
      on = on * -1 + 1;
    }
    
    // Clear All
    
    if (keyCode == BACKSPACE) {
      for (int x = 0 ; x < 8; x++) {
    for (int y = 0; y < 16; y ++) {
      symbols [x][y] = ". . . .";
      values [x][y] = 0;
    }
      }
    }
}


      



      

    









    
    


 
  
  

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#DFDFDF", "tra_on" });
  }
}
